package edu.umd.dawn.common.enums;

import edu.umd.dawn.common.exceptions.BaseExceptions;
import edu.umd.dawn.common.exceptions.DawnException;
import java.util.Map;

public enum Product {
    CORN(50.0);

    public final double baseTemp;

    private Product(double baseTemp) {
        this.baseTemp = baseTemp;
    }

    public Map<String, Double> getStages(String mode, int value) {
        if (!this.equals(CORN)) {
            throw new DawnException(BaseExceptions.PRODUCT_UNSUPPORTED);
        }

        double harvestVal;
        if (mode.equals("rm")) {
            harvestVal = ((((double) value) - 95.0) * 22.0) + 2375.0;
        } else {
            harvestVal = (double) value;
        }

        return Map.of(
                "emergence", harvestVal * 0.07,
                "3LeafCollar", harvestVal * 0.13,
                "6LeafCollar", harvestVal * 0.2,
                "silk", harvestVal * 0.545,
                "milk", harvestVal * 0.725,
                "harvest", harvestVal);
    }
}
