package edu.umd.dawn.common.jwt;

import com.auth0.jwt.JWTCreator.Builder;
import com.auth0.jwt.interfaces.DecodedJWT;

import edu.umd.dawn.common.entities.User;
import lombok.AllArgsConstructor;
import lombok.Getter;

@Getter
@AllArgsConstructor
public class Claims {

    private String userId;

    public static Claims build(JWTUtil parser) {
        return new Claims(parser.getJwt().getClaim("id").asString());
    }

    public static Claims build(DecodedJWT jwt) {
        return new Claims(jwt.getClaim("id").asString());
    }

    public static Claims fromUser(User user) {
        return new Claims(user.getId());
    }

    public Builder fill(Builder jwtBuilder) {
        jwtBuilder.withClaim("id", this.userId);
        return jwtBuilder;
    }
}
